package com.perforce.hive.plugin.docker.model;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardOpenOption;

public class DockerBlob {

	private Path path;

	private long offset = 0;

	public DockerBlob(Path path) {
		this.path = path;
	}

	public long write(byte[] bytes) throws IOException {
		Files.createDirectories(path.getParent());
		Files.write(path, bytes, StandardOpenOption.TRUNCATE_EXISTING, StandardOpenOption.CREATE);
		long length = Files.size(path);
		offset += length;
		return length;
	}

	public String read() throws IOException {
		byte[] bytes = Files.readAllBytes(path);
		String json = new String(bytes);
		return json;
	}

	public void complete(String digest) throws IOException {
		Path completed = path.resolveSibling(digest);
		Files.move(path, completed);
		path = completed;
	}

	public void cancel() throws IOException {
		Files.delete(path);
	}

	public boolean exists() {
		return Files.exists(path);
	}

	public long getOffset() {
		return offset;
	}

	public long getLength() throws IOException {
		return Files.size(path);
	}

}
